
;*******************************
;*          Lambo II           *
;*******************************
; By Jeff Frohwein

; Last edit 17-Aug-97

        INCLUDE "hardware.inc"

;Version 1.2 or later of 'hardware.inc' is required.
        rev_Check_hardware_inc 1.5

SpriteRoutine EQU $ff80
SPEED_X   EQU     134
SPEED_Y   EQU     20
SPEED_XI  EQU     10
DigitBase EQU     52
MAX_SPEED EQU     275
CAR_POS_X EQU     72
CAR_POS_Y EQU     142

; Sound effects
SKIDDING        EQU     7
SOUND_FX_OFF    EQU     $ff

        SECTION "Low Ram",BSS

SpriteTable     DS      160
DigitString     DS      6
CarX            DB
Distance        DB
WinX            DB
Curve           DB              ;Keeps track of road curve direction
Speed           DW
RsubVar         DW
VBlankDone      DB
SpeedInc        DB
StripeDelta     DB
Distance1       DW
RoadPtr         DW
CityDelta       DB
BendAmount      DB              ;Keep track of road bend amount
CarAdjOldPtr    DB
ScrollOldPtr    DB
Turning         DB              ;Not 0 when turning
toggle          DB
SndChnl3        DB
Vc96a           DB
Vc96b           DB
Vc96c           DB
Vc96d           DB
Vc96e           DB
Vc96f           DB
Vc970           DB
Vc971           DB
Vc972           DB
anime           DB

        SECTION "Org $0",HOME
        ret

        SECTION "Org $40",HOME[$40]
        jp      VBlankIntr

        SECTION "Org $48",HOME[$48]
        jp      LCDIntr

; DMA copy sprite data to sprite ram

VBlankFirst:
;        push    af
        ld      a,$c0 ;SpriteTable/256
        ldh     [rDMA],a
        ld      a,$28
VBlnkW: dec     a
        jr      nz,VBlnkW
;        pop     af
        ret
VBlankLast:

        DB      "Date 970817"           ; Date stamping info for
                                        ; reference use only
        SECTION "Org $100",HOME[$100]

;*** Beginning of rom execution point ***

        nop
        jp      begin

        NINTENDO_LOGO                   ; Nintendo graphic logo

;Rom Header Info

;    0123456789ABCDEF
 DB "LAMBO II DEMO",0,0,0     ; Cart name   16bytes
 DB 0,0,0                     ; Not used
 DB CART_ROM                  ; Cart type
 DB CART_ROM_256K             ; ROM Size (in bits)
 DB CART_RAM_NONE             ; RAM Size (in bits)
 DB $7e,$ff                       ; Maker ID
 DB 0                         ; Version     =0
 DB $e2                       ; Complement check (important)
 DW $c40e                     ; Checksum (not important)

        SECTION "Org $200",HOME[$200]

        DB      $00,$00         ;1
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00         ;10
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00         ;20
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00         ;30
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00         ;40
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00         ;50
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00         ;60
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00         ;70
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00         ;80
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00

        DB      $00,$00         ;90

        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10

        DB      $30,$00

; Library Includes

        INCLUDE "keypad.asm"
        INCLUDE "memory1.asm"
        INCLUDE "export.asm"

;Version 1.2 or later of 'keypad.asm' is required.
        rev_Check_keypad_asm 1.2
;Version 1.0 or later of 'memory1.asm' is required.
        rev_Check_memory1_asm 1.0
;Version 1.7 or later of 'pan1.asm' is required.
;        rev_Check_pan1_asm 1.7
;Version 1.1 or later of 'u161632a.asm' is required.
;        rev_Check_u161632a_asm 1.1

begin:
        di
                  ; The stack initializes to $FFFE

        ld      a,0
        ldh     [rIE],a         ;disable interrupts
        ldh     [rIF],a

; Must be in VBL before turning the screen off.
WaitVBL:
        ldh    a,[rLY]         ; $ff44=LCDC Y-Pos
        cp     $90             ; $90 and bigger = in VBL
        jr     c,WaitVBL       ; Loop until it is $90 or >

        ld     a,%00010001
        ldh    [rLCDC],a        ; Turn screen off for memory copy

; Copy Sprite handler to high ram

        ld      hl,VBlankFirst
        ld      de,SpriteRoutine
        ld      b,VBlankLast-VBlankFirst
loadh:  ld      a,[hl+]
        ld      [de],a
        inc     de
        dec     b
        jr      nz,loadh

; Clear sprite table

        ld      hl,SpriteTable
        ld      a,4*40
koopa:  ld      [hl],0
        inc     hl
        dec     a
        jr      nz,koopa

        call    DrawCarForward

        ld      a,$e4
        ldh     [rBGP],a         ; Setup default background colors

        ld      hl,TileData+1
        ld      de,$8000
        ld      bc,$1000
        call    mem_Copy         ; Copy tile set to memory

        ld      hl,MapData+4
        ld      de,$9800
        ld      bc,$0400
        call    mem_Copy

;        ld      hl,MapData
;        xor     a
;        call    pan_Init         ; Initialize map

;        ld      de,96
;        ld      hl,300
;        call    pan_Absolute     ; Pan to section of map with Mario

; Set Wave RAM to square wave

        ld      c,$30
        xor     a
l02f7:  ld      [c],a
        inc     c
        bit     3,c
        jr      z,l02f7
        dec     a
l02fe:  ld      [c],a
        inc     c
        bit     4,c
        jr      z,l02fe

        xor     a
        ldh     [$1a],a
        ld      a,$8f
        ldh     [$1a],a
        ld      a,$6f
        ldh     [$1b],a
        ld      a,$80
        ldh     [$1e],a

        ld      a,0
        ldh     [rSCX],a
        ld      a,0
        ldh     [rSCY],a

        ld      a,7
        ldh     [rWX],a
        ld      a,144
        ldh     [rWY],a

        ld      a,$d0
        ld      [$ff48],a       ; setup sprite palette 0 colors
        ld      [$ff49],a       ; setup sprite palette 1 colors

; Interrupt Initialize

        ld      a,0
        ldh     [$ad],a
        ld      a,90
        ldh     [$45],a
        ld      a,$dc
        ldh     [$8e],a

        ld      a,$00
        ldh     [$8f],a
        ldh     [$95],a
        ldh     [$96],a

        ld      a,$4
        ldh     [$90],a

        ld      a,$4a  ;48
        ldh     [$91],a
        ld      a,$40 ;40
        ldh     [$92],a

        ld      a,13
        ld      [Distance],a

        call    l5770

        ld      hl,$200
        ld      de,$dc00
        ld      bc,$200
loadcurv:
        ld      a,[hl+]
        ld      [de],a
        inc     de
        dec     bc
        ld      a,b
        or      c
        jr      nz,loadcurv

        ld      a,$30           ;middle of road offset
        ld      [$c445],a

        xor     a
        ld      [CarX],a
        ld      [WinX],a
        ld      [Curve],a
        ld      [StripeDelta],a
        ld      [BendAmount],a
        ld      [SpeedInc],a
        ld      [Turning],a

        ld      [Speed],a
        ld      [Speed+1],a

        ld      [Distance1],a
        ld      [Distance1+1],a

        ld      hl,RoadMap
        ld      a,l
        ld      [RoadPtr],a
        ld      a,h
        ld      [RoadPtr+1],a

        call    CurvPtr
        call    l0bf3

        ld      a,$40
        ldh     [rSTAT],a

        call    DisplaySpeed

        ld      a,LCDCF_ON|LCDCF_BG8000|LCDCF_BG9800|LCDCF_BGON|LCDCF_OBJ16|LCDCF_OBJON|LCDCF_WINON
;        ld      a,%10010011
        ldh     [rLCDC],a        ; Turn screen on

        ld      a,3
        ldh     [rIE],a          ; Enable LCD & VBlank interrupt

        ei

; Main Loop

        ld      a,SOUND_FX_OFF
        ld      [SndChnl3],a
loop:
        call    PowerDown       ; Wait for an interrupt
        call    DisplaySpeed    ; Display car speed
        call    StripeUpdate    ; Update road stripes
        call    RoadCurves      ; Update road curves
        call    CityScroll      ; Scroll background scene
        call    CarAdjust       ; Adjust car sprite for curves
        call    EngineSound     ; Do engine sounds
        call    SoundFX         ; Do chnl #3 sound effects
        call    Controls        ; Process GB buttons
;        call    Smoke
        jr      loop

; Get and process steering, throttle, & brake.

Controls:
        call    pad_Read

        push    af

        bit     PADB_LEFT,a
        jr      z,Cont1

        ld      a,[Speed]
        ld      b,a
        ld      a,[Speed+1]
        or      b               ;Is speed 0?
        jr      z,Cont3         ;yes, don't move car

        ld      a,[Speed+1]
        or      a               ;Is speed too high?
        jr      z,SkidLno       ;no, no skid sound

        ld      a,SKIDDING
        ld      [SndChnl3],a
        call    SmokeLeft
        jr      SkidL
SkidLno:
        ld      a,SOUND_FX_OFF
        ld      [SndChnl3],a
        call    SmokeOff
SkidL:
        ld      a,[CarX]
        dec     a
        ld      [CarX],a
        call    l1b74
        ld      a,1
        ld      [Turning],a
        call    DrawCarLeft

        jr      Cont3

Cont1:
        bit     PADB_RIGHT,a
        jr      z,Cont2

        ld      a,[Speed]
        ld      b,a
        ld      a,[Speed+1]
        or      b               ;Is speed 0?
        jr      z,Cont3         ;yes, don't move car

        ld      a,[Speed+1]
        or      a               ;Is speed too high?
        jr      z,SkidRno       ;no, no skid sound

        ld      a,SKIDDING
        ld      [SndChnl3],a
        call    SmokeRight
        jr      SkidR
SkidRno:
        ld      a,SOUND_FX_OFF
        ld      [SndChnl3],a
        call    SmokeOff
SkidR:

        ld      a,[CarX]
        inc     a
        ld      [CarX],a
        call    l1b74
        ld      a,1
        ld      [Turning],a
        call    DrawCarRight

        jr      Cont3

Cont2:
        ld      a,SOUND_FX_OFF
        ld      [SndChnl3],a

        xor     a
        ld      [Turning],a
        call    DrawCarForward

        call    SmokeOff
Cont3:
        pop     af

        ld      c,1
        bit     PADB_A,a        ;Is accelerate pressed?
        jr      z,Cont4         ;No
        ld      c,3
Cont4:
        bit     PADB_B,a        ;Is brake pressed?
        jr      z,Cont5         ;No
        inc     c
Cont5:

        dec     c               ;Is A or B pressed?
        jr      z,WindDrag      ;no, do wind drag slowdown
        dec     c               ;Is B pressed only?
        jr      z,Deaccel       ;yes, deaccelerate
        dec     c               ;Is A pressed only?
        ret     nz              ;no, do nothing

        ld      a,[SpeedInc]
        and     1
        jp      nz,MaxSpd

        ld      a,[Speed]       ;Accelerate
        ld      l,a
        ld      a,[Speed+1]
        ld      h,a
        or      a
        jr      z,NotMax
        ld      a,l
        cp      MAX_SPEED-256
        jr      nc,MaxSpd
NotMax:
        inc     hl
        ld      a,l
        ld      [Speed],a
        ld      a,h
        ld      [Speed+1],a
MaxSpd:
        ret

Deaccel:
        call    WindDrag

; Wind drag slows down car

WindDrag:
        ld      a,[SpeedInc]
        and     1
        jp      nz,drag2

        ld      a,[Speed]
        ld      l,a
        ld      a,[Speed+1]
        ld      h,a
        or      l               ;Is speed 0?
        jr      z,drag1         ;yes, can't go backwards
        dec     hl
drag1:
        ld      a,l
        ld      [Speed],a
        ld      a,h
        ld      [Speed+1],a

drag2:  ret

; Do engine sounds

EngineSound:
        ld      hl,Speed
        ld      a,[hl+]
        or      [hl]            ;Is car moving?
        jr      z,EngineIdle    ;no

        xor     a
        ldh     [$10],a
        ld      d,[hl]
        dec     l
        ld      e,[hl]

        push    de
        pop     hl
        add     hl,hl
        srl     d
        rr      e
        srl     d
        rr      e
        add     hl,de
        push    hl
        pop     de      ;de = speed * 2.25

; Add coarseness to engine sound

        call    EngineCoarseness

        ld      a,$fe          ;new
        ldh     [$12],a
;        srl     e
;        rr      d
        ld      a,e
        ldh     [$13],a
;        ld      a,d
;        and     0 ;7
;        ld      d,a
;        ldh     a,[$14]
;        or      d
;        or      $80             ;new
        ld      a,$86
        ldh     [$14],a
        ret

EngineIdle:
        ld      a,$fe
        ldh     [$11],a
        ldh     [$12],a
        ld      a,1
        ldh     [$10],a
        ld      a,$be  ;be
        ldh     [$13],a
        ld      a,$80
        ldh     [$14],a
        ret

ENGINE_TONE     EQU     3

; Add courseness to engine sound

EngineCoarseness:
        ld      a,[toggle]
        cpl
        ld      [toggle],a
        and     $1
        jr      z,EngineCX

        ld      a,e
        cp      ENGINE_TONE     ;Is speed too low?
        jr      c,EngineCX      ;yes, don't mess with sound

EngineC1:
        ld      a,e
        sub     ENGINE_TONE
        ld      e,a
EngineCX:
        ret

; Service Sound chnl 3 sound effects
;   Execute sound effect in SndChnl3
SoundFX:
        ld      a,[SndChnl3]
        cp      $ff
        jp      z,l2c6e
        ld      a,[Vc96c]
        srl     a
        jr      c,l2c10
l2bde:  ld      a,[SndChnl3]
        add     a,a
        ld      e,a
        ld      d,0
        ld      hl,l2d1d
        add     hl,de
        ld      a,[hl+]
        ld      h,[hl]
        ld      l,a
l2beb:  ld      a,[hl+]
        ld      [Vc96e],a
        ld      a,[hl+]
        ld      [Vc96f],a
        ld      a,[hl+]
        ld      [Vc96d],a
        ld      a,[hl+]
        ld      [Vc970],a
        ld      a,[hl+]
        ld      [Vc971],a
        ld      a,[hl+]
        ld      [Vc972],a
        ld      a,l
        ld      [Vc96a],a
        ld      a,h
        ld      [Vc96b],a
        ld      a,1
        ld      [Vc96c],a
l2c10:  ld      a,[Vc96d]
        or      a
        jr      z,l2c4f
        dec     a
        ld      [Vc96d],a
; Do skidding around corners sound.
        ld      a,[Vc96e]
        ld      e,a
        ld      a,[Vc96f]
        ld      d,a
        ld      a,[Vc970]
        ld      l,a
        ld      a,[Vc971]
        ld      h,a
        add     hl,de
        ld      a,l
        ld      [Vc96e],a
        ld      a,h
        ld      [Vc96f],a
        xor     a
        ldh     [$1e],a
        ldh     a,[$26]
        res     2,a
        ldh     [$26],a
        ld      a,e
        ldh     [$1d],a
        ld      a,$20
        ldh     [$1c],a
        ld      a,d
        and     7
        or      $80
        ldh     [$1e],a
        ld      a,$80
        ldh     [$1a],a
        ret

l2c4f:  ld      a,[Vc972]
        or      a
        jr      z,l2c6a
        bit     7,a
        jr      nz,l2bde
        xor     a
        ld      [Vc96c],a
        ld      [Vc96d],a
        ld      a,[Vc96a]
        ld      l,a
        ld      a,[Vc96b]
        ld      h,a
        jr      l2beb

l2c6a:  ld      a,$ff
        ld      [SndChnl3],a
l2c6e:  xor     a
        ldh     [$1a],a
        ldh     [$1c],a
        ld      [Vc96c],a
        ld      [Vc96d],a
        ret

; Sound effects data table index
l2d1d:   dw     l2d37,l2d3d,l2d55,l2d55,l2d5b,l2d61,l2d67,l2d73,l2d7f
         dw     l2d85,l2d91,l2d97,l2d9d
; Sound effects data table
;   WORD ; Starting sound value
;   BYTE ; Sound length
;   WORD ; Value to add to starting sound value
;   BYTE ; Value: (0=do once, >$7f=repeat, <$80=do next sound)
l2d37:   db     $c6,7,3,3,0,0
l2d3d:   db     $f4,6,$50,2,0,1,$94,7,$28,$fe,$ff,1,$44,7,$28,2,0
         db     1,$94,7,$50,$fe,$ff,$ff
l2d55:   db     $e8,3,$0f,$0f,0,0
l2d5b:   db     $f8,7,$64,$f6,$ff,0
l2d61:   db     $d0,7,$0a,4,0,0
l2d67:   db     $d0,7,$0a,0,0,1,0,0,$0a,0,0,$ff
l2d73:   db     $d0,7,3,$ff,$ff,1,$cd,7,3,1,0,$ff
l2d7f:   db     $6c,7,6,$fe,$ff,0
l2d85:   db     $f8,7,$14,$fb,$ff,1,$fe,6,$14,5,0,0
l2d91:   db     $e8,3,5,$0a,0,0
l2d97:   db     $6c,7,$0a,$fe,$ff,0
l2d9d:   db     $fe,$96,2,6,$1c,0

; Have car creep towards outside of curves

CarAdjust:
        ld      a,[BendAmount]
        or      a               ;Is road bending right now?
        ret     z               ;no

        ld      a,[Speed]
        ld      b,a
        ld      a,[Speed+1]
        or      b               ;Is speed 0?
        ret     z               ;yes, no creep takes place

        ld      a,[CarAdjOldPtr]
        ld      b,a
        ld      a,[RoadPtr]
        and     15
        cp      b
        ret     z               ;We've already adjusted

        ld      [CarAdjOldPtr],a

        ld      a,[Curve]       ;Figure out which way road
        or      a               ;is bending and take car
        ld      b,$ff           ;same direction.
        jr      z,CarA2
        ld      b,1
CarA2:
        ld      a,[CarX]
        add     a,b
        ld      [CarX],a
        call    l1b74
        ret

; Update road curves

RoadCurves:
        ld      a,[Distance1]
        ld      l,a
        ld      a,[Distance1+1]
        ld      h,a

        ld      a,[Speed]
        ld      e,a
        ld      a,[Speed+1]
        ld      d,a

        add     hl,de

        ld      a,l
        ld      [Distance1],a
        ld      a,h
        and     1
        ld      [Distance1+1],a

        ld      a,h
;        srl     a
        srl     a               ; A = Road position

        push    af
        ld      a,[RoadPtr]
        ld      l,a
        ld      a,[RoadPtr+1]
        ld      h,a

        pop     af
        ld      e,a
        ld      d,0
        add     hl,de

Curve1:
        ld      a,l
        ld      [RoadPtr],a
        ld      a,h
        ld      [RoadPtr+1],a

        ld      a,[hl+]
        cp      $fe             ;Swap curve?
        jr      z,CurveWrap     ;yes

        cp      $ff             ;End of table?
        ld      hl,RoadMap
        jr      z,CurveWrap     ;Yes, wrap around

        ld      [BendAmount],a
        call    CurvPtr
        call    l0bf3
        ret

CurveWrap:
        ld      a,[Curve]
        xor     2
        ld      [Curve],a

        or      a
        ld      a,$30
        jr      z,Curve2
        ld      a,$2e
Curve2:
        ld      [$c445],a

        jr      Curve1

RoadMap:
        DB      $00,$00,$00,$00,$00,$00,$00,$00
        DB      $00,$01,$02,$03,$04,$05,$06,$07
        DB      $08,$09,$0a,$0b,$0c,$0d,$0e,$0f
        DB      $10,$11,$12,$13,$14,$15,$16,$17
        DB      $18,$19,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $1a,$1a,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $1a,$1a,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $1a,$1a,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $1a,$1a,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $1a,$1a,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $1a,$1a,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $1a,$1a,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $1a,$1a,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $1a,$1a,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $19,$18,$17,$16,$15,$14,$13,$12
        DB      $11,$10,$0f,$0e,$0d,$0c,$0b,$0a
        DB      $09,$08,$07,$06,$05,$04,$03,$02
        DB      $00,$00,$00,$00,$00,$00,$00,$00
        DB      $00,$00,$00,$00,$00,$00,$00,$00
        DB      $00,$00,$00,$00,$00,$00,$00,$00
        DB      $fe
        DB      $00,$00,$00,$00,$00,$00,$00,$00
        DB      $00,$01,$02,$03,$04,$05,$06,$07
        DB      $08,$09,$0a,$0b,$0c,$0d,$0e,$0f
        DB      $10,$11,$12,$13,$14,$15,$16,$17
        DB      $18,$19,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $1a,$1a,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $1a,$1a,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $1a,$1a,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $1a,$1a,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $1a,$1a,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $1a,$1a,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $1a,$1a,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $1a,$1a,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $1a,$1a,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $19,$18,$17,$16,$15,$14,$13,$12
        DB      $11,$10,$0f,$0e,$0d,$0c,$0b,$0a
        DB      $09,$08,$07,$06,$05,$04,$03,$02
        DB      $00,$00,$00,$00,$00,$00,$00,$00
        DB      $00,$00,$00,$00,$00,$00,$00,$00
        DB      $00,$00,$00,$00,$00,$00,$00,$00
        DB      $fe
        DB      $00,$00,$00,$00,$00,$00,$00,$00
        DB      $00,$01,$02,$03,$04,$05,$06,$07
        DB      $08,$09,$0a,$0b,$0c,$0d,$0e,$0f
        DB      $10,$11,$12,$13,$14,$15,$16,$17
        DB      $18,$19,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $19,$18,$17,$16,$15,$14,$13,$12
        DB      $11,$10,$0f,$0e,$0d,$0c,$0b,$0a
        DB      $09,$08,$07,$06,$05,$04,$03,$02
        DB      $fe
        DB      $00,$01,$02,$03,$04,$05,$06,$07
        DB      $08,$09,$0a,$0b,$0c,$0d,$0e,$0f
        DB      $10,$11,$12,$13,$14,$15,$16,$17
        DB      $18,$19,$1a,$1a,$1a,$1a,$1a,$1a
        DB      $19,$18,$17,$16,$15,$14,$13,$12
        DB      $11,$10,$0f,$0e,$0d,$0c,$0b,$0a
        DB      $09,$08,$07,$06,$05,$04,$03,$02
        DB      $00,$00,$00,$00,$00,$00,$00,$00
        DB      $ff

; Scroll City depending on curve amount

CityScroll:
        ld      a,[BendAmount]
        ld      d,a

;        ld      b,0
        ld      a,[Speed]
        ld      c,a
        ld      a,[Speed+1]
        or      c               ;Is speed 0?
        jr      z,CitySX        ;Yes

        ld      a,[ScrollOldPtr]
        ld      b,a
        ld      a,[RoadPtr]
        and     3
        cp      b
        ret     z               ;We've already adjusted

        ld      [ScrollOldPtr],a

;        ld      a,[Turning]
;        or      a               ;Is car turning?
;        ret     z               ;no, no scroll

        ld      a,[CityDelta]
        add     a,d
        ld      b,a
        and     $1f
        ld      [CityDelta],a

        ld      a,b
        rlca
        rlca
        rlca
        and     7
        jr      z,CitySX

        ld      a,[Curve]
        or      a
        ld      b,1
        jr      z,CityS1
        ld      b,$ff
CityS1:
        ld      a,[WinX]
        add     b
        ld      [WinX],a

CitySX:
        ret

; Convert speed to stripes to display

StripeUpdate:
        ld      a,[Speed]
        ld      e,a
        ld      a,[Speed+1]
        ld      d,a

        ld      a,[StripeDelta]
        ld      l,a
        ld      h,0

        add     hl,de

        ld      a,l
        and     127
        ld      [StripeDelta],a

        sla     l
        ld      a,h
        rla
        ld      b,a

        ld      a,[Distance]
        sub     b
        and     15
        ld      [Distance],a
        ret

; LCDC Interrupt Routine

LCDIntr:
        di
        push    af
        push    de
        push    hl
        ldh     a,[$ad]
        srl     a
        jr      c,l297d

        ldh     a,[$45]
        ld      l,a
        ld      h,0
        inc     a
        cp      144             ; $90
        jr      nz,l2947
        ld      a,90            ; $5a
l2947:  ldh     [$45],a

; Set scroll Y register
        ldh     a,[$8e]         ;$dc00 or $de00 is put here
        ld      d,a
        ld      e,h
        add     hl,hl
        add     hl,de
        ld      a,[hl+]
        ld      e,a
        ld      a,[hl]
        ldh     [$42],a

; Set scroll X register
        ldh     a,[$45]
        sub     90-2            ; $58
        ld      l,a
        ld      h,$db           ; Point to user perspective table
        ld      a,e
        add     a,[hl]
        ldh     [$43],a         ; ScrollX =  [$db+sl] + $8e.x

        ld      e,l
        ld      d,0
        ldh     a,[$8f]
        ld      l,a
        ldh     a,[$90]
        ld      h,a
        add     hl,de
        bit     0,[hl]
        jr      z,l2975

        ldh     a,[$92]
        ldh     [$47],a
        pop     hl
        pop     de
        pop     af
        reti

l2975:  ldh     a,[$91]
        ldh     [$47],a
        pop     hl
        pop     de
        pop     af
        reti

l297d:  ldh     a,[$45]
        ld      l,a
        inc     a
        cp      $50
        jr      nz,l2987
        ld      a,$40
l2987:  ldh     [$45],a
        ld      a,l
        sub     $40
        ld      l,a
        ld      h,0
        ld      de,l299a
        add     hl,de
        ld      a,[hl]
        ldh     [$42],a
        pop     hl
        pop     de
        pop     af
        reti

l299a:  DB      $ff,$ff,$fe,$fe,$fd,$fd,$fc,$fc
        DB      $fb,$fb,$fa,$fa,$f9,$f9,$f8,$f8

; VBlank Interrupt Routine

VBlankIntr:
        di
        push    af
        push    de
        push    hl

        ldh     a,[$95]         ;Should we swap road curve tables?
        srl     a
        jp      nc,l29e7        ;no
        ldh     [$95],a

        ld      h,$de
        ldh     a,[$96]
        cpl
        ldh     [$96],a
        or      a
        jr      z,l29d4
        dec     h
        dec     h
l29d4:  ld      a,h
        ldh     [$8e],a
l29e7:

        ld      a,$e4           ;Set Background color
        ldh     [rBGP],a

        ld      a,[WinX]
        ldh     [$43],a
        xor     a
        ldh     [$42],a

        call    SpriteRoutine

        ld      a,[Distance]
        add     a,a
        ld      l,a
        ld      h,0
        ld      de,Stripes
        add     hl,de
        ld      a,[hl+]
        ldh     [$8f],a
        ld      a,[hl]
        ldh     [$90],a

        ld      a,1
        ld      [VBlankDone],a

        ld      a,[SpeedInc]
        inc     a
        ld      [SpeedInc],a

        pop     hl
        pop     de
        pop     af
        reti

;Halt until VBlank

PowerDown:
        halt

        ld      a,[VBlankDone]
        rra
        jr      nc,PowerDown

        xor     a
        ld      [VBlankDone],a
        ret

; Copy rom X coord curve table w[$c44c] to the current ram table.

l0bf3:
;        ld      a,(0c478h)
;        srl     a
;        ret     c

        ld      hl,$dc00        ; Point hl to unused curve table
;        ldh     a,[$96]
;        or      a
;        jr      z,l0c03
;        inc     h
;        inc     h
;l0c03:  call    ClearTab        ; Set all bytes to zero in table

;        ld      a,1
;        call    l2dc3
        ld      de,l5c7c
        ld      a,[de]
        ldh     [$8d],a
        push    hl
        ld      l,a
        ld      h,0
        ld      b,a
        ld      a,$90
        sub     b               ; b = $90 - $58 = 56
        ld      [$c474],a
        ld      b,a
        add     hl,hl
        pop     de
        add     hl,de           ; hl = CurveTable + [$58 * 2]

;        ld      a,4
;        call    l2dc3

        ld      a,[$c44c]
        ld      e,a
        ld      a,[$c44d]
        ld      d,a
        ldh     a,[$8d]
        push    hl
        ld      l,a
        ld      h,0
        add     hl,de
        ld      e,l
        ld      d,h             ; de = w[$c44c] + $58
        pop     hl

l0c37:  push    bc              ; install x coords in curve table
        ld      a,[de]
        ld      c,a
        ld      a,[$c445]
        add     a,c
        ld      [hl+],a         ; [hl] = [de] + [$c445]
        inc     hl
        inc     de
        pop     bc
        dec     b
        jr      nz,l0c37

        ret                 ; < - quit early!!!

;        ld      a,1
;        call    l2dc3

        dec     hl
        ld      de,l5c7c
        push    hl
        ld      a,[$c474]
        ld      b,a             ; b = number of Y coords to install
        ld      a,$48
        ld      l,a
        ld      h,0
        add     hl,de
        ld      e,l
        ld      d,h             ; de = l5c7c + $48
        pop     hl

        ldh     a,[$99]
        ld      c,a
        ld      a,$3e
        sub     c
        ld      [$c466],a       ; [$c466] = $3e - [$99]

        ld      c,$90
l0c67:  push    bc
        ld      a,[de]
        ld      c,a
        ld      a,[$c461]
        sub     c
        jr      nc,l0c76

        inc     hl
        inc     hl
        ld      a,[hl-]
        dec     hl
        jr      l0c86

l0c76:  pop     bc
        push    bc
        ld      a,[de]
        sub     c
        cpl
        add     a,1
        ld      c,a
        ld      a,[$c466]
        add     a,c
        ld      c,a             ; c = [$c466] + (~([de]-c)) + 1
        ldh     a,[$99]
        add     a,c
l0c86:  ld      [hl-],a
        ld      a,[de]
        ld      [$c461],a
        dec     hl
        dec     de
        pop     bc
        dec     c
        dec     b
        jr      nz,l0c67

;        ld      a,1
;        call    l2dc3
        ret


;l0cf9:
;        ld      a,($c441)       ; 0cf9 fa 41 c4   zAD
;        srl     a               ; 0cfc cb 3f   K?
;        jr      c,l0d05         ; 0cfe 38 05   8.
;        ld      a,1             ; 0d00 3e 01   >.
;        ld      ($c441),a       ; 0d02 ea 41 c4   jAD

;l0d05:
;        ld      a,($c45a)       ; 0d05 fa 5a c4   zZD
;        cp      $ff             ; 0d08 fe ff   ..
;        jr      z,l0d35         ; 0d0a 28 29   ()
;        ld      b,a
;        dec     a
;        ld      ($c45a),a
;        ld      a,($c456)

CurvPtr:
;        ld      a,[Curve]
        ld      b,a
        ld      a,[Curve]

        ld      l,a
        ld      h,0
        add     hl,hl
        ld      de,Curves
        add     hl,de
        ld      a,[hl+]
        ld      h,[hl]
        ld      l,a             ; hl = [Curves+(a*2)]
        ld      a,b
        add     a,a
        ld      e,a
        ld      d,0
        add     hl,de           ; hl = [Curves+(a*2)] + (b*2)
        ld      a,[hl+]
        ld      h,[hl]
        ld      l,a             ; hl = [[Curves+(a*2)] + (b*2)]
        ld      [$c44c],a
        ld      a,h
        ld      [$c44d],a
;        ld      a,1
;        call    l2dc3
        ret

; Set $200 bytes to $00 at HL
ClearTab:
        push    hl
        ld      bc,$200
ClearT1:
        xor     a
        ld      [hl+],a
        dec     bc
        ld      a,b
        or      c
        jr      nz,ClearT1
        pop     hl
        ret

l5c7c:  DB      $58,$5a,$5a,$5b,$5c,$5d,$5e,$60,$60,$62,$62,$64,$64
        DB      $66,$66,$67,$68,$69,$6a,$6b,$6b,$6d,$6d,$6e,$6f,$70,$70
        DB      $72,$72,$73,$74,$75,$75,$76,$77,$78,$78,$7a,$7a,$7b,$7c
        DB      $7d,$7d,$7e,$7f,$80,$80,$82,$82,$83,$83,$85,$85,$86,$86
        DB      $88,$88,$89,$89,$8b,$8b,$8c,$8c,$8d,$8d,$8e,$8e,$8f,$8f
        DB      $90,$90,$90,$91,$91,$92,$92,$92

; Convert A to a user perspective view

l1b74:
;        ld      a,($c45c)
;        or      a
;        ret     z

        ld      c,a
        bit     7,a
        jr      z,l1b81
        cpl
        add     a,1
l1b81:  add     a,a
        ld      l,a
        ld      h,0
;        ld      a,7
;        call    l2dc3
        ld      de,UserPer
        add     hl,de
        ld      a,[hl+]
        ld      h,[hl]
        ld      l,a
        ld      d,$db
        ld      e,0
        ld      b,$39
l1b97:  ld      a,[hl+]
        bit     7,c
        jr      z,l1b9f
        cpl
        add     a,1
l1b9f:  ld      [de],a
        inc     de
        dec     b
        jr      nz,l1b97
;        ld      a,1
;        call    l2dc3
        ret

l5770:  xor     a
        ld      h,$db
        ld      l,0
        ld      b,$ff
l5777:  ld      [hl+],a
        dec     b
        jr      nz,l5777
        ret

; Display speed on screen

DisplaySpeed:
        ld      a,[Speed]
        ld      l,a
        ld      a,[Speed+1]
        ld      h,a
        ld      de,DigitString
        call    cns

        ld      a,SPEED_Y
        ld      [SpriteTable+16],a
        ld      a,SPEED_X
        ld      [SpriteTable+17],a
        ld      a,[DigitString+2]
;        ld      a,DigitBase+2
        ld      [SpriteTable+18],a
        ld      a,$0
        ld      [SpriteTable+19],a

        ld      a,SPEED_Y
        ld      [SpriteTable+20],a
        ld      a,SPEED_X+SPEED_XI
        ld      [SpriteTable+21],a
        ld      a,[DigitString+3]
        ld      [SpriteTable+22],a
        ld      a,$0
        ld      [SpriteTable+23],a

        ld      a,SPEED_Y
        ld      [SpriteTable+24],a
        ld      a,SPEED_X+(SPEED_XI*2)
        ld      [SpriteTable+25],a
        ld      a,[DigitString+4]
        ld      [SpriteTable+26],a
        ld      a,$0
        ld      [SpriteTable+27],a
        ret

; Show smoke from tires

SmokeLeft:
        ld      a,[anime]
        inc     a
        cp      9
        jr      c,smok1
        xor     a
smok1:
        ld      [anime],a
        srl     a
        srl     a

        dec     a
        jr      z,next
        dec     a
        jr      z,last

        ld      a,CAR_POS_Y+7
        ld      [SpriteTable+28],a
        ld      a,CAR_POS_X-10
        ld      [SpriteTable+29],a
        ld      a,$58
        ld      [SpriteTable+30],a
        ld      a,$0
        ld      [SpriteTable+31],a

        ld      a,CAR_POS_Y+7
        ld      [SpriteTable+32],a
        ld      a,CAR_POS_X-2
        ld      [SpriteTable+33],a
        ld      a,$5a
        ld      [SpriteTable+34],a
        ld      a,$0
        ld      [SpriteTable+35],a
        ret
next:
        ld      a,CAR_POS_Y+7
        ld      [SpriteTable+28],a
        ld      a,CAR_POS_X-10
        ld      [SpriteTable+29],a
        ld      a,$5c
        ld      [SpriteTable+30],a
        ld      a,$0
        ld      [SpriteTable+31],a

        ld      a,CAR_POS_Y+7
        ld      [SpriteTable+32],a
        ld      a,CAR_POS_X-2
        ld      [SpriteTable+33],a
        ld      a,$5e
        ld      [SpriteTable+34],a
        ld      a,$0
        ld      [SpriteTable+35],a
        ret
last:
        ld      a,CAR_POS_Y+7
        ld      [SpriteTable+28],a
        ld      a,CAR_POS_X-10
        ld      [SpriteTable+29],a
        ld      a,$60
        ld      [SpriteTable+30],a
        ld      a,$0
        ld      [SpriteTable+31],a

        ld      a,CAR_POS_Y+7
        ld      [SpriteTable+32],a
        ld      a,CAR_POS_X-2
        ld      [SpriteTable+33],a
        ld      a,$62
        ld      [SpriteTable+34],a
        ld      a,$0
        ld      [SpriteTable+35],a
        ret

SmokeRight:
        ld      a,[anime]
        inc     a
        cp      9
        jr      c,smok2
        xor     a
smok2:
        ld      [anime],a
        srl     a
        srl     a

        dec     a
        jr      z,next2
        dec     a
        jr      z,last2

        ld      a,CAR_POS_Y+7
        ld      [SpriteTable+28],a
        ld      a,CAR_POS_X+34
        ld      [SpriteTable+29],a
        ld      a,$58
        ld      [SpriteTable+30],a
        ld      a,$20
        ld      [SpriteTable+31],a

        ld      a,CAR_POS_Y+7
        ld      [SpriteTable+32],a
        ld      a,CAR_POS_X+26
        ld      [SpriteTable+33],a
        ld      a,$5a
        ld      [SpriteTable+34],a
        ld      a,$20
        ld      [SpriteTable+35],a
        ret
next2:
        ld      a,CAR_POS_Y+7
        ld      [SpriteTable+28],a
        ld      a,CAR_POS_X+34
        ld      [SpriteTable+29],a
        ld      a,$5c
        ld      [SpriteTable+30],a
        ld      a,$20
        ld      [SpriteTable+31],a

        ld      a,CAR_POS_Y+7
        ld      [SpriteTable+32],a
        ld      a,CAR_POS_X+26
        ld      [SpriteTable+33],a
        ld      a,$5e
        ld      [SpriteTable+34],a
        ld      a,$20
        ld      [SpriteTable+35],a
        ret
last2:
        ld      a,CAR_POS_Y+7
        ld      [SpriteTable+28],a
        ld      a,CAR_POS_X+34
        ld      [SpriteTable+29],a
        ld      a,$60
        ld      [SpriteTable+30],a
        ld      a,$20
        ld      [SpriteTable+31],a

        ld      a,CAR_POS_Y+7
        ld      [SpriteTable+32],a
        ld      a,CAR_POS_X+26
        ld      [SpriteTable+33],a
        ld      a,$62
        ld      [SpriteTable+34],a
        ld      a,$20
        ld      [SpriteTable+35],a
        ret

SmokeOff:
        ld      a,CAR_POS_Y+100
        ld      [SpriteTable+28],a
        ld      a,0
        ld      [SpriteTable+29],a
        ld      a,$60
        ld      [SpriteTable+30],a
        ld      a,$0
        ld      [SpriteTable+31],a

        ld      a,CAR_POS_Y+100
        ld      [SpriteTable+32],a
        ld      a,0
        ld      [SpriteTable+33],a
        ld      a,$62
        ld      [SpriteTable+34],a
        ld      a,$0
        ld      [SpriteTable+35],a
        ret

; Show car pointing forward

DrawCarForward:
        ld      a,CAR_POS_Y
        ld      [SpriteTable+0],a
        ld      a,CAR_POS_X
        ld      [SpriteTable+1],a
        ld      a,48  ;spr number
        ld      [SpriteTable+2],a
        ld      a,$0
        ld      [SpriteTable+3],a

        ld      a,CAR_POS_Y
        ld      [SpriteTable+4],a
        ld      a,CAR_POS_X+8
        ld      [SpriteTable+5],a
        ld      a,50  ;spr number
        ld      [SpriteTable+6],a
        ld      a,$0
        ld      [SpriteTable+7],a

        ld      a,CAR_POS_Y
        ld      [SpriteTable+8],a
        ld      a,CAR_POS_X+16
        ld      [SpriteTable+9],a
        ld      a,50  ;spr number
        ld      [SpriteTable+10],a
        ld      a,$20
        ld      [SpriteTable+11],a

        ld      a,CAR_POS_Y
        ld      [SpriteTable+12],a
        ld      a,CAR_POS_X+24
        ld      [SpriteTable+13],a
        ld      a,48  ;spr number
        ld      [SpriteTable+14],a
        ld      a,$20
        ld      [SpriteTable+15],a
        ret

; Show car pointing left

DrawCarLeft:
        ld      a,CAR_POS_Y
        ld      [SpriteTable+0],a
        ld      a,CAR_POS_X
        ld      [SpriteTable+1],a
        ld      a,80  ;spr number
        ld      [SpriteTable+2],a
        ld      a,$0
        ld      [SpriteTable+3],a

        ld      a,CAR_POS_Y
        ld      [SpriteTable+4],a
        ld      a,CAR_POS_X+8
        ld      [SpriteTable+5],a
        ld      a,82  ;spr number
        ld      [SpriteTable+6],a
        ld      a,$0
        ld      [SpriteTable+7],a

        ld      a,CAR_POS_Y
        ld      [SpriteTable+8],a
        ld      a,CAR_POS_X+16
        ld      [SpriteTable+9],a
        ld      a,84  ;spr number
        ld      [SpriteTable+10],a
        ld      a,$0
        ld      [SpriteTable+11],a

        ld      a,CAR_POS_Y
        ld      [SpriteTable+12],a
        ld      a,CAR_POS_X+24
        ld      [SpriteTable+13],a
        ld      a,86  ;spr number
        ld      [SpriteTable+14],a
        ld      a,$0
        ld      [SpriteTable+15],a

        ret

; Show car pointing right

DrawCarRight:
        ld      a,CAR_POS_Y
        ld      [SpriteTable+0],a
        ld      a,CAR_POS_X
        ld      [SpriteTable+1],a
        ld      a,86  ;spr number
        ld      [SpriteTable+2],a
        ld      a,$20
        ld      [SpriteTable+3],a

        ld      a,CAR_POS_Y
        ld      [SpriteTable+4],a
        ld      a,CAR_POS_X+8
        ld      [SpriteTable+5],a
        ld      a,84  ;spr number
        ld      [SpriteTable+6],a
        ld      a,$20
        ld      [SpriteTable+7],a

        ld      a,CAR_POS_Y
        ld      [SpriteTable+8],a
        ld      a,CAR_POS_X+16
        ld      [SpriteTable+9],a
        ld      a,82  ;spr number
        ld      [SpriteTable+10],a
        ld      a,$20
        ld      [SpriteTable+11],a

        ld      a,CAR_POS_Y
        ld      [SpriteTable+12],a
        ld      a,CAR_POS_X+24
        ld      [SpriteTable+13],a
        ld      a,80  ;spr number
        ld      [SpriteTable+14],a
        ld      a,$20
        ld      [SpriteTable+15],a

        ret

; Clear screen

clsgr:  ld      hl,$8000
        ld      d,0
        ld      e,16            ; x2=4096
clsgr2: xor     a               ; A = 0
        ld      [hl+],a
        dec     d
        jr      nz,clsgr2
        dec     e
        jr      nz,clsgr2
        ret

initscr:
        ld      hl,$9800        ; First clear the screen
        ld      e,4
cloop1: ld      d,0
cloop2: di
;        HV_WAIT
        ld      a,$ff           ; This char (0ffh) isn't used for GFX.
        ld      [hl+],a
        ei

        dec     d
        jr      nz,cloop2
        dec     e
        jr      nz,cloop1
        ld      b,0
        ld      hl,$9822        ; Now draw the 16*15 matrix
        ld      e,$f
loop10: ld      d,$10
loop20: di
;        HV_WAIT
        ld      a,b
        swap    a               ; The screen must be rotated by 90.
        ld      [hl+],a
        ei

        inc     b
        dec     d
        jr      nz,loop20
        push    de
        ld      d,0
        ld      e,$10
        add     hl,de
        pop     de
        dec     e
        jr      nz,loop10

        ret

; convert integer to string
; de = addr of string
; hl = value to convert
; exit:	de = updated value
;
cns:
        ld      a,1            ;set for leading zeroes
	ld	bc,-10000
	call	rsub
	ld	bc,-1000
	call	rsub
	ld	bc,-100
	call	rsub
	ld	bc,-10
	call	rsub
	ld	bc,-1
	call	rsub
	ret	nz
        ld      a,DigitBase
        ld      [de],a
	inc	de
	ret
;
; Take value in hl sub # in bc the
; most possible times.
; Put value on string at de.
; If a=0 then don't put zero on string.
; Return non-zero if a put on string
;
rsub:	push	de
        push    af
	ld	d,-1

rsub1:  ld      a,l
        ld      [RsubVar],a
        ld      a,h
        ld      [RsubVar+1],a
        inc     d
        add     hl,bc
        jr      c,rsub1

        ld      a,[RsubVar]
        ld      l,a
        ld      a,[RsubVar+1]
        ld      h,a

        pop     af
        ld      b,d
	pop	de
	or	b	     ;a gets 0 if a was 0 and b is 0
	ret	z

        ld      a,DigitBase
        add     a,b
        add     a,b
;        ld      a,2
        ld      [de],a
	inc	de
	ret

        SECTION "Bank 1",CODE
UserPer:
        INCLUDE "userper.asm"   ;Include user perspective tables
Stripes:
        INCLUDE "stripes.asm"   ;Include road side strip tables
Curves:
        INCLUDE "curves.asm"     ;Include road curve tables

